#include <sstream>
#include <string>
#include <curl/curl.h>
#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;


struct Input {
    vector<double> numbers;
    size_t bin_count{};
    size_t number_count{};
    size_t max_count{};
};

Input
input_data(istream& in, bool prompt) {
    if (prompt==true){
    Input input;
    cerr << "Enter number count: ";
    in >> input.number_count;

    vector<double> numbers(input.number_count);
    input.numbers.resize(input.number_count);
    for (size_t i = 0; i < input.number_count; i++) {
        in >> input.numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    in >> input.bin_count;

    size_t max_count;
    input.max_count = 0;
    return input;
    }

    if (prompt==false){
    Input input;

    in >> input.number_count;

    vector<double> numbers(input.number_count);
    input.numbers.resize(input.number_count);
    for (size_t i = 0; i < input.number_count; i++) {
        in >> input.numbers[i];
    }

    size_t bin_count;
    in >> input.bin_count;

    size_t max_count;
    input.max_count = 0;
    return input;
    }
}


size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    buffer->write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}



Input
download(const string& address) {
    stringstream buffer;
    CURL *curl = curl_easy_init();
    curl_version_info_data *curl_version_info(CURLversion protocols);
    if(curl) {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        curl_easy_cleanup(curl);
        if (res!=0){
            cout<<res;
            exit(1);
            }

            curl_version_info_data *ver = curl_version_info(CURLVERSION_NOW);
            cerr<<(curl_version_info(CURLVERSION_NOW));
        }
    curl_global_init(CURL_GLOBAL_ALL);
    return input_data(buffer, false);
}



int main(int argc, char* argv[])
{
    Input in;
    if (argc > 1) {
        in = download(argv[1]);
    }
    else {
        in = input_data(cin, true);
    }
    const auto bins = make_histogram(in.numbers, in.bin_count, in.number_count, in.max_count);
    vector<double> test;
    show_histogram_svg(bins, in.max_count, in.bin_count, test);

    return 0;
}
